HDU 4585 Shaolin(Treap找前驱和后继)

Shaolin

Time Limit: 3000/1000 MS (Java/Others)    Memory Limit: 65535/32768 K (Java/Others)
Total Submission(s): 3191    Accepted Submission(s): 1350

Problem Description

Shaolin temple is very famous for its Kongfu monks.A lot of young men go to Shaolin temple every year, trying to be a monk there. The master of Shaolin evaluates a young man mainly by his talent on understanding the Buddism scripture, but fighting skill is also taken into account.
When a young man passes all the tests and is declared a new monk of Shaolin, there will be a fight , as a part of the welcome party. Every monk has an unique id and a unique fighting grade, which are all integers. The new monk must fight with a old monk whose fighting grade is closest to his fighting grade. If there are two old monks satisfying that condition, the new monk will take the one whose fighting grade is less than his.
The master is the first monk in Shaolin, his id is 1,and his fighting grade is 1,000,000,000.He just lost the fighting records. But he still remembers who joined Shaolin earlier, who joined later. Please recover the fighting records for him.

Input

There are several test cases.
In each test case:
The first line is a integer n (0 <n <=100,000),meaning the number of monks who joined Shaolin after the master did.(The master is not included).Then n lines follow. Each line has two integer k and g, meaning a monk‘s id and his fighting grade.( 0<= k ,g<=5,000,000)
The monks are listed by ascending order of jointing time.In other words, monks who joined Shaolin earlier come first.
The input ends with n = 0.

Output

A fight can be described as two ids of the monks who make that fight. For each test case, output all fights by the ascending order of happening time. Each fight in a line. For each fight, print the new monk‘s id first ,then the old monk‘s id.

Sample Input

3

2 1

3 3

4 2

0

Sample Output

2 1

3 2

4 2

题目链接:HDU 4585

题意就是少林寺里有一个初始的人,他的id是1,武力值是1e9,然后按照输入顺序有n个人来少林寺挑战,输出n行,对应每一个来挑战的人给他分配的对手是谁。如何分配对手的规则题目已经讲了。

简单的做法就是建一颗Treap,然后在树上进行二分答案,找前驱与后继再比较判断得出答案即可,水题一道

代码:

#include <bits/stdc++.h>
using namespace std;
#define INF 0x3f3f3f3f
#define LC(x) (x<<1)
#define RC(x) ((x<<1)+1)
#define MID(x,y) ((x+y)>>1)
#define fin(name) freopen(name,"r",stdin)
#define fout(name) freopen(name,"w",stdout)
#define CLR(arr,val) memset(arr,val,sizeof(arr))
#define FAST_IO ios::sync_with_stdio(false);cin.tie(0);
typedef pair<int, int> pii;
typedef long long LL;
const double PI = acos(-1.0);
const int N = 100010;
struct Treap
{
    int ls, rs, v, sz, id;
    int rnd;
};
Treap T[N];
int rt, tot;

void init()
{
    rt = 0;
    tot = 0;
}
void pushup(int k)
{
    T[k].sz = T[T[k].ls].sz + T[T[k].rs].sz + 1;
}
void lturn(int &k)
{
    int rs = T[k].rs;
    T[k].rs = T[rs].ls;
    T[rs].ls = k;
    T[rs].sz = T[k].sz;
    pushup(k);
    k = rs;
}
void rturn(int &k)
{
    int ls = T[k].ls;
    T[k].ls = T[ls].rs;
    T[ls].rs = k;
    T[ls].sz = T[k].sz;
    pushup(k);
    k = ls;
}
void ins(int &k, int v, int id)
{
    if (!k)
    {
        k = ++tot;
        T[k].ls = T[k].rs = 0;
        T[k].v = v, T[k].id = id;
        T[k].sz = 1;
        T[k].rnd = rand();
    }
    else
    {
        ++T[k].sz;
        if (v < T[k].v)
        {
            ins(T[k].ls, v, id);
            if (T[T[k].ls].rnd < T[k].rnd)
                rturn(k);
        }
        else
        {
            ins(T[k].rs, v, id);
            if (T[T[k].rs].rnd < T[k].rnd)
                lturn(k);
        }
    }
}
void get_pre(int k, int v, int &ans)
{
    if (!k)
        return ;
    if (T[k].v < v)
    {
        ans = k;
        get_pre(T[k].rs, v, ans);
    }
    else
        get_pre(T[k].ls, v, ans);
}
void get_post(int k, int v, int &ans)
{
    if (!k)
        return ;
    if (T[k].v > v)
    {
        ans = k;
        get_post(T[k].ls, v, ans);
    }
    else
        get_post(T[k].rs, v, ans);
}
int main(void)
{
    srand(987654321);
    int n;
    while (~scanf("%d", &n) && n)
    {
        init();
        ins(rt, 1e9, 1);
        while (n--)
        {
            int id, v;
            scanf("%d%d", &id, &v);
            int pre = -1, post = -1;
            get_pre(rt, v, pre);
            get_post(rt, v, post);
            if (pre == -1)
                printf("%d %d\n", id, T[post].id);
            else if (post == -1)
                printf("%d %d\n", id, T[pre].id);
            else
            {
                int dxpre = abs(v - T[pre].v), dxpost = abs(v - T[post].v);
                if (dxpre < dxpost)
                    printf("%d %d\n", id, T[pre].id);
                else if (dxpre > dxpost)
                    printf("%d %d\n", id, T[post].id);
                else
                    printf("%d %d\n", id, T[pre].id);
            }
            ins(rt, v, id);
        }
    }
    return 0;
}
时间: 2024-11-05 22:40:58

HDU 4585 Shaolin(Treap找前驱和后继)的相关文章

HDU 4585 ShaoLin 基础Treap

这题其实就是一个在二叉搜索树里面找前驱和后继的题,以前好像用线段树+离散化搞过,弄得比较挫,学会AVL了之后就是方便. 简单说一下怎么找前驱和后继, 前驱的话,如果当前节点有左子树,那么前驱就是左子树中的最大节点,否则往上找第一个是他父亲节点的右儿子的节点,后继和前驱差不多,反过来就行. 因为我这里没有存parent指针,如果存的话旋转起来比较麻烦,所以我是先从根找到这个节点,沿途记录了一下. #include <cstdio> #include <climits> #includ

hdu 4585 Shaolin两种方法(暴力和STL)

转载请注明出处:http://blog.csdn.net/u012860063 题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4585 Problem Description Shaolin temple is very famous for its Kongfu monks.A lot of young men go to Shaolin temple every year, trying to be a monk there. The mast

HDU 4585 Shaolin(STL map)

Shaolin Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u Submit Status Practice HDU 4585 Description Shaolin temple is very famous for its Kongfu monks.A lot of young men go to Shaolin temple every year, trying to be a mon

二叉搜索树找前驱和后继

输入N个数,找每个数的前驱和后继.如果没有前驱或后继,输出-1: 思路: 如果有右子树,则右子树的最小值为当前节点的后继:否则后继为当前节点往祖先搜索,第一次是左孩子的节点的父亲的值: 如果有左子树,则左子树的最大值为当前节点的前驱:否则前驱为当前节点往祖先搜索,第一次是右孩子的节点的父亲的值: #include "bits/stdc++.h" using namespace std; typedef long long LL; const int INF = 0x3f3f3f3f;

hdu 4585 Shaolin两种方法(暴力和STL map set)

转载请注明出处:http://blog.csdn.net/u012860063 题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4585 Problem Description Shaolin temple is very famous for its Kongfu monks.A lot of young men go to Shaolin temple every year, trying to be a monk there. The mast

[HDU 4585] Shaolin (map应用)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4585 题目大意:不停的插入数字,问你跟他相距近的ID号.如果有两个距离相近的话选择小的那个. 用map,先用upper_bound找到大的,然后迭代器减1,就能够找到相近的两个. 然后..用链表不知道为什么有问题.... 而且迭代器it,如果减1的话,不能写 it2 = --it1; 这样会wa 但是..it2 = it1; it2--;这样就AC了,在这里记录一下,今后注意. 1 //#pragm

hdu 4585 shaolin 平衡树

Description Shaolin temple is very famous for its Kongfu monks.A lot of young men go to Shaolin temple every year, trying to be a monk there. The master of Shaolin evaluates a young man mainly by his talent on understanding the Buddism scripture, but

hdu 4585 Shaolin(STL map)

Problem Description Shaolin temple is very famous for its Kongfu monks.A lot of young men go to Shaolin temple every year, trying to be a monk there. The master of Shaolin evaluates a young man mainly by his talent on understanding the Buddism script

HDU 4585 Shaolin(map应用+二分)

题目大意:原题链接 初始少林最开始只有一个老和尚,很多人想进少林,每个人有一个武力值,若某个人想进少林,必须先与比他早进去的并且武力值最接近他的和尚比武, 如果接近程度相同则选择武力值比他小的,按照进入少林的先后顺序,求出每个和尚进去的时候应当和哪个和尚比武. #include<map> #include<iostream> using namespace std; int main() { int n,id,g; map<int,int>::iterator it,p